

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Pango.Structs
    (     module GI.Pango.Structs.Analysis        ,
    module GI.Pango.Structs.AttrClass       ,
    module GI.Pango.Structs.AttrColor       ,
    module GI.Pango.Structs.AttrFloat       ,
    module GI.Pango.Structs.AttrFontDesc    ,
    module GI.Pango.Structs.AttrFontFeatures,
    module GI.Pango.Structs.AttrInt         ,
    module GI.Pango.Structs.AttrIterator    ,
    module GI.Pango.Structs.AttrLanguage    ,
    module GI.Pango.Structs.AttrList        ,
    module GI.Pango.Structs.AttrShape       ,
    module GI.Pango.Structs.AttrSize        ,
    module GI.Pango.Structs.AttrString      ,
    module GI.Pango.Structs.Attribute       ,
    module GI.Pango.Structs.Color           ,
    module GI.Pango.Structs.Coverage        ,
    module GI.Pango.Structs.EngineInfo      ,
    module GI.Pango.Structs.EngineScriptInfo,
    module GI.Pango.Structs.FontDescription ,
    module GI.Pango.Structs.FontMetrics     ,
    module GI.Pango.Structs.GlyphGeometry   ,
    module GI.Pango.Structs.GlyphInfo       ,
    module GI.Pango.Structs.GlyphItem       ,
    module GI.Pango.Structs.GlyphItemIter   ,
    module GI.Pango.Structs.GlyphString     ,
    module GI.Pango.Structs.GlyphVisAttr    ,
    module GI.Pango.Structs.IncludedModule  ,
    module GI.Pango.Structs.Item            ,
    module GI.Pango.Structs.Language        ,
    module GI.Pango.Structs.LayoutIter      ,
    module GI.Pango.Structs.LayoutLine      ,
    module GI.Pango.Structs.LogAttr         ,
    module GI.Pango.Structs.Map             ,
    module GI.Pango.Structs.MapEntry        ,
    module GI.Pango.Structs.Matrix          ,
    module GI.Pango.Structs.Rectangle       ,
    module GI.Pango.Structs.ScriptIter      ,
    module GI.Pango.Structs.TabArray        ,


    ) where

import GI.Pango.Structs.Analysis
import GI.Pango.Structs.AttrClass
import GI.Pango.Structs.AttrColor
import GI.Pango.Structs.AttrFloat
import GI.Pango.Structs.AttrFontDesc
import GI.Pango.Structs.AttrFontFeatures
import GI.Pango.Structs.AttrInt
import GI.Pango.Structs.AttrIterator
import GI.Pango.Structs.AttrLanguage
import GI.Pango.Structs.AttrList
import GI.Pango.Structs.AttrShape
import GI.Pango.Structs.AttrSize
import GI.Pango.Structs.AttrString
import GI.Pango.Structs.Attribute
import GI.Pango.Structs.Color
import GI.Pango.Structs.Coverage
import GI.Pango.Structs.EngineInfo
import GI.Pango.Structs.EngineScriptInfo
import GI.Pango.Structs.FontDescription
import GI.Pango.Structs.FontMetrics
import GI.Pango.Structs.GlyphGeometry
import GI.Pango.Structs.GlyphInfo
import GI.Pango.Structs.GlyphItem
import GI.Pango.Structs.GlyphItemIter
import GI.Pango.Structs.GlyphString
import GI.Pango.Structs.GlyphVisAttr
import GI.Pango.Structs.IncludedModule
import GI.Pango.Structs.Item
import GI.Pango.Structs.Language
import GI.Pango.Structs.LayoutIter
import GI.Pango.Structs.LayoutLine
import GI.Pango.Structs.LogAttr
import GI.Pango.Structs.Map
import GI.Pango.Structs.MapEntry
import GI.Pango.Structs.Matrix
import GI.Pango.Structs.Rectangle
import GI.Pango.Structs.ScriptIter
import GI.Pango.Structs.TabArray

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL



